//+-------------------------------------------------------------------+
//|                                                    RSIMACD EA.mq4 |
//|                                    Mail: successful_coder@mail.ru |
//|                           Muzaffar Ergashaliev, Uzbekistan  2015 |
//+-------------------------------------------------------------------+
#property copyright "successfulcoder ( from MQL5.com )  2015"
#property link "https://www.mql5.com/en/users/successfulcoder/portfolio"
#property version "1.00"
#property strict

input string NameEA                           = "RSIMACD EA";//EA Name 
input string                                 _="------------------<  Indicator Settings  >-----------------";
input string          ________________________="xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx";//_________MACD Indicator 
input int    Price2                           = 8;            //Price
input int    method2                          = 12;           //Fast Period 
input int    price2                           = 26;           //Slow Period 
input int    period2                          = 9;            //Signal Period
input int    method3                          = 2;            //Method 
input string         _________________________="xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx";//__________RSI Indicator
input int    RSI_period                       = 14;           //Period
input ENUM_APPLIED_PRICE RSI_Price            = PRICE_CLOSE;  //Price
input double Buylevel_RSI                     = 65;           //Up level
input double Selllevel_RSI                    = 35;           //Down level
input string  ________________________________="xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx";//_________Trade Parameters
input double FixedLots                        = 0.1;          //Lot Size
input double StopLoss                         = 20;           //Stop Loss
input double TakeProfits                      = 20;           //Take Profit
input bool   CloseAtOpposSignal               = 0;            //Exit by Oppos.Signal 
input string      ____________________________="xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx";//_________Other Parameters
input int    MagicNumber                      = 123;          //Magic Number
input bool   Commentary                       = 0;            //Comment on Chart
input int    MaxOpenOrders                    = 1;            //Max.Open Orders
//MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM
int      PipValue=1,digit_lot=0,Lot_Digits,buy1=0,sell1=0;
double   ClosingArray[100],Lots,risk,LastLot=0,Sloss,Tprof,point,AllProfit=0;
bool     Buy=0,Sell=0,Buy2=0,Sell2=0,Buy3=0,Sell3=0,comm4=0;
//MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
   if((Bid<10 && _Digits==5)||(Bid>10 && _Digits==3)){PipValue= 10;}
   if((Bid<10 && _Digits==4)||(Bid>10 && _Digits==2)){PipValue= 1;}
   point = PipValue*Point;
   if(MarketInfo(Symbol(),MODE_LOTSTEP)>=0.01) digit_lot=2;   
   if(MarketInfo(Symbol(),MODE_LOTSTEP)>=0.1) digit_lot=1;   
   if(MarketInfo(Symbol(),MODE_LOTSTEP)>=1) digit_lot=0;
   return(INIT_SUCCEEDED);
  }   
//*------------------------------------------------------------------*
double GetPoint(string TradeSymbol = "")
{
   GetTradeSymbol(TradeSymbol);
   if(StringFind(TradeSymbol,"XAU")>-1 || StringFind(TradeSymbol,"xau")>-1 || StringFind(TradeSymbol,"GOLD")>-1) return(0.1);  //Gold
   if(MarketInfo(TradeSymbol,MODE_DIGITS)==2 || MarketInfo(TradeSymbol,MODE_DIGITS)==3) return(0.01);
   if(MarketInfo(TradeSymbol,MODE_DIGITS)==4 || MarketInfo(TradeSymbol,MODE_DIGITS)==5) return(0.0001);
   if(MarketInfo(TradeSymbol,MODE_DIGITS)==0) return(1); //Indexes
   return(0.0001);
}
//*------------------------------------------------------------------*
void GetTradeSymbol(string& TradeSymbol) 
{ 
   if(TradeSymbol=="") TradeSymbol=Symbol(); 
}  
//OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO
//+------------------------------------------------------------------+
//|  Get Signals                                                     |                     
//+------------------------------------------------------------------+
void Indicators(){   

    Buy  = (iRSI(NULL,0,RSI_period,RSI_Price,1) > Selllevel_RSI && iRSI(NULL,0,RSI_period,RSI_Price,2) < Selllevel_RSI);
    Sell = (iRSI(NULL,0,RSI_period,RSI_Price,1) < Buylevel_RSI && iRSI(NULL,0,RSI_period,RSI_Price,2) > Buylevel_RSI); 

    Buy2 = (iCustom(NULL,0,"MACD_OsMA_ColorLH_new",4,1) > iCustom(NULL,0,"MACD_OsMA_ColorLH_new",5,1) && 
            iCustom(NULL,0,"MACD_OsMA_ColorLH_new",4,2) < iCustom(NULL,0,"MACD_OsMA_ColorLH_new",5,2));
    Sell2= (iCustom(NULL,0,"MACD_OsMA_ColorLH_new",4,1) < iCustom(NULL,0,"MACD_OsMA_ColorLH_new",5,1) && 
            iCustom(NULL,0,"MACD_OsMA_ColorLH_new",4,2) > iCustom(NULL,0,"MACD_OsMA_ColorLH_new",5,2));  
            
    Buy3 = (iRSI(NULL,0,RSI_period,RSI_Price,1) > Selllevel_RSI && iRSI(NULL,0,RSI_period,RSI_Price,2) < Selllevel_RSI);
    Sell3= (iRSI(NULL,0,RSI_period,RSI_Price,1) < Buylevel_RSI && iRSI(NULL,0,RSI_period,RSI_Price,2) > Buylevel_RSI);            
}                     
//HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH   
//+------------------------------------------------------------------+
//|  Lot Size                                                        |
//+------------------------------------------------------------------+
void LotsSize(){    
    Lots = FixedLots;      
    if(Lots<MarketInfo(Symbol(),MODE_MINLOT)) Lots=MarketInfo(Symbol(),MODE_MINLOT);
    if(Lots>MarketInfo(Symbol(),MODE_MAXLOT)) Lots=MarketInfo(Symbol(),MODE_MAXLOT);
}     
//MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM  
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason){}

//HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH
//+------------------------------------------------------------------+
//| CloseBuy                                                         |
//+------------------------------------------------------------------+     
 int CloseBuy(){
 int i=OrdersTotal()-1;
  for(i=OrdersTotal()-1;i>=0;i--){
   bool os = OrderSelect(i,SELECT_BY_POS);
   if(OrderSymbol()==Symbol() && OrderMagicNumber() == MagicNumber){    
     if(OrderType()==OP_BUY)       
      bool oc = OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(MarketInfo(Symbol(),MODE_BID),
     (int)MarketInfo(Symbol(),MODE_DIGITS)),1000,Gold);  
     int x=0;
     for(x=0;x<100;x++){
      if(ClosingArray[x]==0){
       ClosingArray[x]=OrderTicket();
       break;
       }}}}
       return(1);}
//MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM
//+------------------------------------------------------------------+
//| CloseSell                                                        |
//+------------------------------------------------------------------+     
 int CloseSell(){
 int i=OrdersTotal()-1;
  for(i=OrdersTotal()-1;i>=0;i--){
   bool os = OrderSelect(i,SELECT_BY_POS);
   if(OrderSymbol()==Symbol() && OrderMagicNumber() == MagicNumber){    
     if(OrderType()==OP_SELL)       
      bool oc = OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(MarketInfo(Symbol(),MODE_ASK),
      (int)MarketInfo(Symbol(),MODE_DIGITS)),1000,Gold);
     int x=0;
     for(x=0;x<100;x++){
      if(ClosingArray[x]==0){
       ClosingArray[x]=OrderTicket();
       break;
       }}}}
       return(1);}
//HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH//
//+------------------------------------------------------------------+
//| Get total order                                                  |
//+------------------------------------------------------------------+
int Orders(int type)
  {
   int count=0;
   //-1= All,0=Buy,1=Sell,2=BuyLimit,3=SellLimit,4=BuyStop,5=SellStop;   
   for(int x=OrdersTotal()-1;x>=0;x--)
      {
      if(OrderSelect(x,MODE_TRADES)){ 
      if(OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber) 
        {
         if(type < 0){ count++;}
         if(OrderType() == type && type >= 0){ count++;}         
        }}}   
   return(count);
  }      
//MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM
void Closer(){  
   for(int i = 0; i < OrdersTotal(); i++) {
       bool os = OrderSelect(i, SELECT_BY_POS);    
       if(OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber && CloseAtOpposSignal){  
         if(OrderType() == OP_BUY) 
            {  
           if(Sell)
            {CloseBuy();}}
         if(OrderType() == OP_SELL) 
            {  
           if(Buy)
            {CloseSell();}}}}}       
//HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH 
//+------------------------------------------------------------------+
//| Expert start function                                            |
//+------------------------------------------------------------------+
void OnTick(){

     LotsSize();Indicators();int num = Orders(-1);Closer(); 
//OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO    
    bool band = 0,ban = 0;
    for(int i = OrdersTotal() - 1; i >= 0; i--)
    	 if(OrderSelect (i, SELECT_BY_POS))
    	 {        
	     if(OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber) 
       {
       if(OrderOpenTime() >= iTime(NULL,0,0)) ban = true;   
       }}
       if(ban){return;}
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx      
    for(int i=OrdersHistoryTotal()-1;i>=0;i--)
       {
       if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)==false) 
       { 
       Print("Error in history!"); break; 
       }
       if(OrderSymbol()!=Symbol() || OrderType()>OP_SELL) continue;
       if(OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber) 
       {
       if(OrderOpenTime() >= iTime(NULL,0,0)) band = true;   
    	 }}
       if(band){return;}
       if(Buy){buy1=1;sell1=0;};
       if(Sell){sell1=1;buy1=0;}       
//MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM              
    if(num < MaxOpenOrders){      
        if(Buy2 && buy1==1){
           if(StopLoss == 0){Sloss = 0;} else{
           Sloss = Ask - StopLoss * point;}
           if(TakeProfits == 0){Tprof = 0;}else{ 
           Tprof = Bid + TakeProfits * point;}
           int Tiketb = OrderSend(Symbol(),OP_BUY,Lots,Ask,3*PipValue,Sloss,Tprof,NameEA,MagicNumber,0,Blue);buy1=0;
           }
        if(Sell2 && sell1==1){                  
           if(StopLoss == 0){Sloss = 0;}else{ 
           Sloss = Bid + StopLoss * point;}
           if(TakeProfits == 0){Tprof = 0;}else{  
           Tprof = Ask - TakeProfits * point;}
           int Tikets = OrderSend(Symbol(),OP_SELL,Lots,Bid,3*PipValue,Sloss,Tprof,NameEA,MagicNumber,0,Red);sell1=0;
           }}                       
//OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO
if(Commentary==true){
Comment(
  "\n",
         NameEA, 
  "\n", "______________________",
  "\n",
  "\n", "Account Number - - - : ", AccountNumber (),
  "\n", "Balance - - - - - - - - - : ",DoubleToStr( AccountBalance(),0),
  "\n", "Current Profit - - - - - : ", DoubleToStr(OrderProfit(),2),
  "\n", "Lots - - - - - - - - - - - : ",DoubleToStr(Lots,2), 
  "\n", "Spread - - - - - - - - - -: ", (MarketInfo(Symbol(), MODE_SPREAD)/PipValue),
    
  "\n", "______________________",
  "\n");}                              
  return;
}
//MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM